#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#
#  BRAMA application extention script invoked from 
#  "Visual configurator for ForthLogic PLC"
#
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~

##########################################################
##########################################################
##########################################################
#
#        A P P L I C A T I O N     G L O B A L S
#
##########################################################
##########################################################
##########################################################

set BramaParam(ADMIN_1) ""
set BramaParam(ADMIN_2) ""
set BramaParam(ADMIN_3) ""
set BramaParam(ADMIN_4) ""
set BramaParam(ADMIN_5) ""
set BramaParam(ADMIN_6) ""

set BramaParam(USER_10) ""
set BramaParam(USER_11) ""
set BramaParam(USER_12) ""
set BramaParam(USER_13) ""
set BramaParam(USER_14) ""
set BramaParam(USER_15) ""
set BramaParam(USER_16) ""
set BramaParam(USER_17) ""
set BramaParam(USER_18) ""
set BramaParam(USER_19) ""

set BramaParam(USER_20) ""
set BramaParam(USER_21) ""
set BramaParam(USER_22) ""
set BramaParam(USER_23) ""
set BramaParam(USER_24) ""
set BramaParam(USER_25) ""
set BramaParam(USER_26) ""
set BramaParam(USER_27) ""
set BramaParam(USER_28) ""
set BramaParam(USER_29) ""

set BramaParam(is_entry_en1) 0
set BramaParam(is_entry_en2) 0
set BramaParam(is_nc) 0
set BramaParam(is_bistabile) 0
set BramaParam(gate_delay) 0.0

set BramaParam(window) .bramawindow

##########################################################
##########################################################
##########################################################
#
#         A P P L I C A T I O N   P R O C E D U R S
#
##########################################################
##########################################################
##########################################################

proc BramaWindowShow {} {
	global BramaParam

	#-----------------------------------------------------
	#   Application window 

	if {[winfo exists $BramaParam(window)]} {wm deiconify $BramaParam(window); return}
	toplevel $BramaParam(window)
    wm title $BramaParam(window) "BRAMA configuration window"
	wm resizable $BramaParam(window) no no
	catch {wm iconbitmap $BramaParam(window) "Application.ico"}

	#-----------------------------------------------------
	#   "Configuration" group 

	grid [ttk::labelframe $BramaParam(window).lf1 -padding 2 -text "Configuration"] -padx 2 -pady 2 -sticky news -columnspan 3 -row 0 -column 0

		ttk::button $BramaParam(window).lf1.b1 -text "Read" -width 15 \
				-command {
					PutStatusLine "Wait..."
					$BramaParam(window) config -cursor watch

					# -----------------------------------------------

					if {![WriteTerminal "1 USER" answer]} {
						scan $answer {%s} BramaParam(ADMIN_1)
					} 
					if {![WriteTerminal "2 USER" answer]} {
						scan $answer {%s} BramaParam(ADMIN_2)
					} 
					if {![WriteTerminal "3 USER" answer]} {
						scan $answer {%s} BramaParam(ADMIN_3)
					} 
					if {![WriteTerminal "4 USER" answer]} {
						scan $answer {%s} BramaParam(ADMIN_4)
					} 
					if {![WriteTerminal "5 USER" answer]} {
						scan $answer {%s} BramaParam(ADMIN_5)
					} 
					if {![WriteTerminal "6 USER" answer]} {
						scan $answer {%s} BramaParam(ADMIN_6)
					} 

					# -----------------------------------------------

					if {![WriteTerminal "10 USER" answer]} {
						scan $answer {%s} BramaParam(USER_10)
					} 
					if {![WriteTerminal "11 USER" answer]} {
						scan $answer {%s} BramaParam(USER_11)
					} 
					if {![WriteTerminal "12 USER" answer]} {
						scan $answer {%s} BramaParam(USER_12)
					} 
					if {![WriteTerminal "13 USER" answer]} {
						scan $answer {%s} BramaParam(USER_13)
					} 
					if {![WriteTerminal "14 USER" answer]} {
						scan $answer {%s} BramaParam(USER_14)
					} 
					if {![WriteTerminal "15 USER" answer]} {
						scan $answer {%s} BramaParam(USER_15)
					} 
					if {![WriteTerminal "16 USER" answer]} {
						scan $answer {%s} BramaParam(USER_16)
					} 
					if {![WriteTerminal "17 USER" answer]} {
						scan $answer {%s} BramaParam(USER_17)
					} 
					if {![WriteTerminal "18 USER" answer]} {
						scan $answer {%s} BramaParam(USER_18)
					} 
					if {![WriteTerminal "19 USER" answer]} {
						scan $answer {%s} BramaParam(USER_19)
					} 

					# -----------------------------------------------

					if {![WriteTerminal "20 USER" answer]} {
						scan $answer {%s} BramaParam(USER_20)
					} 
					if {![WriteTerminal "21 USER" answer]} {
						scan $answer {%s} BramaParam(USER_21)
					} 
					if {![WriteTerminal "22 USER" answer]} {
						scan $answer {%s} BramaParam(USER_22)
					} 
					if {![WriteTerminal "23 USER" answer]} {
						scan $answer {%s} BramaParam(USER_23)
					} 
					if {![WriteTerminal "24 USER" answer]} {
						scan $answer {%s} BramaParam(USER_24)
					} 
					if {![WriteTerminal "25 USER" answer]} {
						scan $answer {%s} BramaParam(USER_25)
					} 
					if {![WriteTerminal "26 USER" answer]} {
						scan $answer {%s} BramaParam(USER_26)
					} 
					if {![WriteTerminal "27 USER" answer]} {
						scan $answer {%s} BramaParam(USER_27)
					} 
					if {![WriteTerminal "28 USER" answer]} {
						scan $answer {%s} BramaParam(USER_28)
					} 
					if {![WriteTerminal "29 USER" answer]} {
						scan $answer {%s} BramaParam(USER_29)
					} 

					# -----------------------------------------------

					if {![WriteTerminal "is_entry_en1 ." answer]} {
						scan $answer {%d} BramaParam(is_entry_en1)
					} 
					if {![WriteTerminal "is_entry_en2 ." answer]} {
						scan $answer {%d} BramaParam(is_entry_en2)
					} 
					if {![WriteTerminal "is_nc ." answer]} {
						scan $answer {%d} BramaParam(is_nc)
					} 
					if {![WriteTerminal "is_bistabile ." answer]} {
						scan $answer {%d} BramaParam(is_bistabile)
					} 
					if {![WriteTerminal "gate_delay F." answer]} {
						scan $answer {%f} BramaParam(gate_delay)
					} 

					# -----------------------------------------------

					$BramaParam(window) config -cursor arrow
					PutStatusLine "Success"
					after 2000 {PutStatusLine ""}
				}
		tooltip::tooltip $BramaParam(window).lf1.b1 "Read BRAMA configuration"

		ttk::button $BramaParam(window).lf1.b2 -text "Write" -width 15 \
				-command {
					PutStatusLine "Wait..."
					$BramaParam(window) config -cursor watch

					# -----------------------------------------------

					WriteTerminal [format ".\" %s \" 1 USERPHONE" $BramaParam(ADMIN_1)] answer
					WriteTerminal [format ".\" %s \" 2 USERPHONE" $BramaParam(ADMIN_2)] answer
					WriteTerminal [format ".\" %s \" 3 USERPHONE" $BramaParam(ADMIN_3)] answer
					WriteTerminal [format ".\" %s \" 4 USERPHONE" $BramaParam(ADMIN_4)] answer
					WriteTerminal [format ".\" %s \" 5 USERPHONE" $BramaParam(ADMIN_5)] answer
					WriteTerminal [format ".\" %s \" 6 USERPHONE" $BramaParam(ADMIN_6)] answer

					# -----------------------------------------------

					WriteTerminal [format ".\" %s \" 10 USERPHONE" $BramaParam(USER_10)] answer
					WriteTerminal [format ".\" %s \" 11 USERPHONE" $BramaParam(USER_11)] answer
					WriteTerminal [format ".\" %s \" 12 USERPHONE" $BramaParam(USER_12)] answer
					WriteTerminal [format ".\" %s \" 13 USERPHONE" $BramaParam(USER_13)] answer
					WriteTerminal [format ".\" %s \" 14 USERPHONE" $BramaParam(USER_14)] answer
					WriteTerminal [format ".\" %s \" 15 USERPHONE" $BramaParam(USER_15)] answer
					WriteTerminal [format ".\" %s \" 16 USERPHONE" $BramaParam(USER_16)] answer
					WriteTerminal [format ".\" %s \" 17 USERPHONE" $BramaParam(USER_17)] answer
					WriteTerminal [format ".\" %s \" 18 USERPHONE" $BramaParam(USER_18)] answer
					WriteTerminal [format ".\" %s \" 19 USERPHONE" $BramaParam(USER_19)] answer

					# -----------------------------------------------

					WriteTerminal [format ".\" %s \" 20 USERPHONE" $BramaParam(USER_20)] answer
					WriteTerminal [format ".\" %s \" 21 USERPHONE" $BramaParam(USER_21)] answer
					WriteTerminal [format ".\" %s \" 22 USERPHONE" $BramaParam(USER_22)] answer
					WriteTerminal [format ".\" %s \" 23 USERPHONE" $BramaParam(USER_23)] answer
					WriteTerminal [format ".\" %s \" 24 USERPHONE" $BramaParam(USER_24)] answer
					WriteTerminal [format ".\" %s \" 25 USERPHONE" $BramaParam(USER_25)] answer
					WriteTerminal [format ".\" %s \" 26 USERPHONE" $BramaParam(USER_26)] answer
					WriteTerminal [format ".\" %s \" 27 USERPHONE" $BramaParam(USER_27)] answer
					WriteTerminal [format ".\" %s \" 28 USERPHONE" $BramaParam(USER_28)] answer
					WriteTerminal [format ".\" %s \" 29 USERPHONE" $BramaParam(USER_29)] answer

					# -----------------------------------------------

					WriteTerminal [format "%d TO is_entry_en1" $BramaParam(is_entry_en1)] answer
					WriteTerminal [format "%d TO is_entry_en2" $BramaParam(is_entry_en2)] answer
					WriteTerminal [format "%d TO is_nc" $BramaParam(is_nc)] answer
					WriteTerminal [format "%d TO is_bistabile" $BramaParam(is_bistabile)] answer
					WriteTerminal [format "%f TOF gate_delay" $BramaParam(gate_delay)] answer

					# -----------------------------------------------

					$BramaParam(window) config -cursor arrow
					PutStatusLine "Success"
					after 2000 {PutStatusLine ""}
				}
		tooltip::tooltip $BramaParam(window).lf1.b2 "Write BRAMA configuration"

		pack $BramaParam(window).lf1.b1 $BramaParam(window).lf1.b2 -fill both -expand yes -side left

	#-----------------------------------------------------
	#   "Admin Phones" group 

	grid [ttk::labelframe $BramaParam(window).lf2 -padding 5 -text "Admins"] -padx 2 -pady 2 -sticky news -row 1 -column 0

		for {set i 1} {$i <= 6} {incr i} {
			ttk::frame $BramaParam(window).lf2.f$i -padding 2
			ttk::label $BramaParam(window).lf2.f$i.l -text "Admin$i:" -width 10
			ttk::entry $BramaParam(window).lf2.f$i.e -width 20 -validate key -invalidcommand bell -validatecommand {expr {[string length %P] < 16}} -textvariable BramaParam(ADMIN_$i)
			pack $BramaParam(window).lf2.f$i.l $BramaParam(window).lf2.f$i.e -fill x -expand yes -side left
			pack $BramaParam(window).lf2.f$i -fill both -expand yes -pady 2
		} 

	#-----------------------------------------------------
	#   "Users 1 Phones" group 

	grid [ttk::labelframe $BramaParam(window).lf3 -padding 5 -text "Users 1 group"] -padx 2 -pady 2 -sticky news -rowspan 2 -row 1 -column 1

		ttk::checkbutton $BramaParam(window).lf3.cb -text "Enable Users 1 group" -onvalue -1 -variable BramaParam(is_entry_en1)
		pack $BramaParam(window).lf3.cb -fill both -expand yes -pady 2

		for {set i 10} {$i <= 19} {incr i} {
			ttk::frame $BramaParam(window).lf3.f$i -padding 2
			ttk::label $BramaParam(window).lf3.f$i.l -text "User[expr {$i - 9}]:" -width 10
			ttk::entry $BramaParam(window).lf3.f$i.e -width 20 -validate key -invalidcommand bell -validatecommand {expr {[string length %P] < 16}} -textvariable BramaParam(USER_$i)
			pack $BramaParam(window).lf3.f$i.l $BramaParam(window).lf3.f$i.e -fill x -expand yes -side left
			pack $BramaParam(window).lf3.f$i -fill both -expand yes -pady 2
		} 

	#-----------------------------------------------------
	#   "Users 2 Phones" group 

	grid [ttk::labelframe $BramaParam(window).lf4 -padding 5 -text "Users 2 group"] -padx 2 -pady 2 -sticky news -rowspan 2 -row 1 -column 2

		ttk::checkbutton $BramaParam(window).lf4.cb -text "Enable Users 2 group" -onvalue -1 -variable BramaParam(is_entry_en2)
		pack $BramaParam(window).lf4.cb -fill both -expand yes -pady 2

		for {set i 20} {$i <= 29} {incr i} {
			ttk::frame $BramaParam(window).lf4.f$i -padding 2
			ttk::label $BramaParam(window).lf4.f$i.l -text "User[expr {$i - 9}]:" -width 10
			ttk::entry $BramaParam(window).lf4.f$i.e -width 20 -validate key -invalidcommand bell -validatecommand {expr {[string length %P] < 16}} -textvariable BramaParam(USER_$i)
			pack $BramaParam(window).lf4.f$i.l $BramaParam(window).lf4.f$i.e -fill x -expand yes -side left
			pack $BramaParam(window).lf4.f$i -fill both -expand yes -pady 2
		} 

	#-----------------------------------------------------
	#   "Parameters" group 

	grid [ttk::labelframe $BramaParam(window).lf5 -padding 5 -text "Output Parameters"] -padx 2 -pady 2 -sticky news -row 2 -column 0

		ttk::labelframe $BramaParam(window).lf5.f2 -text "Type" -padding 2

			ttk::radiobutton $BramaParam(window).lf5.f2.r1 -width 10 -text "NO" -variable BramaParam(is_nc) -value 0
			ttk::radiobutton $BramaParam(window).lf5.f2.r2 -width 10 -text "NC" -variable BramaParam(is_nc) -value -1
			pack $BramaParam(window).lf5.f2.r1 $BramaParam(window).lf5.f2.r2 -fill x -side left -padx 3 -pady 2

		ttk::labelframe $BramaParam(window).lf5.f3 -text "Mode" -padding 2

			ttk::frame $BramaParam(window).lf5.f3.f1 -padding 2

				ttk::radiobutton $BramaParam(window).lf5.f3.f1.r1 -width 10 -text "Bistable" -variable BramaParam(is_bistabile) -value -1
				ttk::radiobutton $BramaParam(window).lf5.f3.f1.r2 -width 10 -text "Monostable" -variable BramaParam(is_bistabile) -value 0
				pack $BramaParam(window).lf5.f3.f1.r1 $BramaParam(window).lf5.f3.f1.r2 -fill x -side left -padx 3 -pady 2

			ttk::frame $BramaParam(window).lf5.f3.f2 -padding 2

				ttk::label $BramaParam(window).lf5.f3.f2.l -text "Pulse width (s):"
				ttk::entry $BramaParam(window).lf5.f3.f2.e -width 10 -validate key -invalidcommand bell -validatecommand {expr {[string length %P] < 10}} -textvariable BramaParam(gate_delay)
				pack $BramaParam(window).lf5.f3.f2.l $BramaParam(window).lf5.f3.f2.e -fill x -expand yes -side left

			pack $BramaParam(window).lf5.f3.f1 $BramaParam(window).lf5.f3.f2 -fill both -expand yes -pady 2

		pack $BramaParam(window).lf5.f2 $BramaParam(window).lf5.f3 -fill both -expand yes -pady 2


	#-----------------------------------------------------
	#   make some beauty on the window

	update
	wm minsize $BramaParam(window) [winfo reqwidth $BramaParam(window)] [winfo reqheight $BramaParam(window)]
}

##########################################################
##########################################################
##########################################################
#
#         A P P L I C A T I O N   M E N U
#
##########################################################
##########################################################
##########################################################

.menubar add cascade -label "BRAMA" -menu .menubar.bramamenu
menu .menubar.bramamenu -tearoff 0
	.menubar.bramamenu add command -label "Configuration window" \
			-command {
						ConnectPLC
						BramaWindowShow
					}
	.menubar.bramamenu add separator
	.menubar.bramamenu add command -label "Program..." \
			-command {
						DisconnectPLC
						ProgramApplication
					}
